package com.iformall.controller.basic;

import com.iformall.annotation.SystemControllerLog;
import com.iformall.controller.base.BaseController;
import io.swagger.annotations.Api;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import com.github.pagehelper.PageInfo;
import com.iformall.common.Result;
import com.iformall.common.ResultData;

import com.iformall.domain.po.WxPayAccount;
import com.iformall.service.WxPayAccountService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;

@RestController
@RequestMapping("wxPayAccount")
@Api(description = "C端小程序支付商户号设置接口")
public class WxPayAccountController extends BaseController {
    private final Logger logger = LoggerFactory.getLogger(this.getClass());

    @Autowired
    private WxPayAccountService wxPayAccountService;

    @ApiOperation("分页列表接口")
    @GetMapping("list")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "页数", dataType = "int", paramType = "query", required = true),
            @ApiImplicitParam(name = "pageSize", value = "每页条数", dataType = "int", paramType = "query", required = true)})
    @SystemControllerLog(description = "支付账号-列表")
    public ResultData list(@ModelAttribute WxPayAccount wxPayAccount, Integer pageNum, Integer pageSize) {
        logger.debug("[" + getIpAddr() + "] WxPayAccountController::list");
        if (null == wxPayAccount) wxPayAccount = new WxPayAccount();
        final PageInfo<WxPayAccount> page = wxPayAccountService.listAsPage(wxPayAccount, pageNum, pageSize);
        return new ResultData(page);
    }

    @ApiOperation("新增接口")
    @PostMapping("add")
    @SystemControllerLog(description = "支付账号-新增")
    public ResultData add(@RequestBody WxPayAccount wxPayAccount) {
        logger.debug("[" + getIpAddr() + "] WxPayAccountController::add");
        //Assert.notNull(wxPayAccount.getName(), "角色名不能为空");
        //Assert.isTrue(!checkUnique(sysRole.getName(), null), "重复的角色名");
        wxPayAccountService.saveOrUpdate(wxPayAccount);
        return new ResultData();
    }

    @ApiOperation("根据id更新接口")
    @PostMapping("update")
    @SystemControllerLog(description = "支付账号-更新")
    public ResultData update(@RequestBody WxPayAccount wxPayAccount) {
        logger.debug("[" + getIpAddr() + "] WxPayAccountController::update");
        wxPayAccountService.saveOrUpdate(wxPayAccount);
        return new ResultData();
    }

    @ApiOperation("根据id删除接口")
    @GetMapping("/del")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    @SystemControllerLog(description = "支付账号-删除")
    public ResultData delete(Long id) {
        logger.debug("[" + getIpAddr() + "] WxPayAccountController::delete");
        wxPayAccountService.deleteById(id);
        return new ResultData(Result.SUCCESS, "删除成功", null);
    }

    @ApiOperation("根据id查询接口")
    @GetMapping("/findById")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    @SystemControllerLog(description = "支付账号-查询")
    public ResultData findById(Long id) {
        logger.debug("[" + getIpAddr() + "] WxPayAccountController::findById");
        return new ResultData(Result.SUCCESS, "查询成功", wxPayAccountService.getById(id));
    }


}
